/* eslint-disable @typescript-eslint/no-empty-interface */
// Generated code for namespace: org.accordproject.finance.bond@0.3.0

// imports
import {IOrganization} from './org.accordproject.organization@0.2.0';
import {IDuration} from './org.accordproject.time@0.3.0';
import {ICurrencyCode} from './org.accordproject.money@0.3.0';
import {IConcept,IAsset} from './concerto@1.0.0';

// interfaces
export enum CouponType {
   FIXED = 'FIXED',
   FLOATING = 'FLOATING',
}

export interface IPaymentFrequency extends IConcept {
   periodMultiplier: number;
   period: IDuration;
}

export interface IBond extends IConcept {
   instrumentId: string[];
   description?: string;
   currency?: CurrencyCode;
   exchangeId: string[];
   clearanceSystem?: string;
   definition?: string;
   seniority?: string;
   couponType?: CouponType;
   couponRate?: number;
   maturity: Date;
   parValue: number;
   faceAmount: number;
   paymentFrequency: IPaymentFrequency;
   dayCountFraction: string;
   issuer: IOrganization;
}

export interface IBondAsset extends IAsset {
   ISINCode: string;
   bond: IBond;
}

